/********************************

	QSpYf

		C

 ********************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<sys\iocs.h>
#include	<sys\dos.h>

#include	"24puzzle.h"
#include	"screen.h"
#include	"pad.h"


BLOCK	field[LEN][LEN];		/*  */
int	field_dx[LEN][LEN];		/* ubNړp */
int	field_dy[LEN][LEN];

static int	spc_x, spc_y;		/* 󔒂̈ʒu */


/***************************************
    ubN̈ړ
		dx, dy = ړ̕
	߂l	ړ
 ***************************************/
static
Bool	move_block(int dx, int dy)
{
	if ( (((spc_x + dx) % 2) || ((spc_y + dy) % 2))
					&& (field[spc_y + dy][spc_x + dx] > 0) ) {
		field[spc_y][spc_x]               = field[spc_y + dy][spc_x + dx];
		field[spc_y + dy][spc_x + dx]     = field[spc_y + dy*2][spc_x + dx*2];
		field[spc_y + dy*2][spc_x + dx*2] = -1;		/* Qړ */
		spc_x += dx*2;
		spc_y += dy*2;
		return	TRUE;
	}
	return	FALSE;
}

/***************************************
    ړAj[V
		dx, dy = ړ̕
	߂l	ړ
 ***************************************/
static
Bool	move(int dx, int dy)
{
	int	i, n;

	if ( move_block(dx, dy) ) {				/* ubN̈ړ */
		for (i = 0; i < 12; i++) {
			n = (i < 8) ? (7 - i)*32 : 0;		/* ڈړ */
			field_dx[spc_y][spc_x - dx*2] = dx*n;
			field_dy[spc_y - dy*2][spc_x] = dy*n;
			n = (i > 4) ? (11- i)*32 : 0x100;	/* ڈړ */
			field_dx[spc_y][spc_x - dx] = dx*n;
			field_dy[spc_y - dy][spc_x] = dy*n;
			draw_screen();				/* ʕ` */
		}
		return	TRUE;
	}
	return	FALSE;
}

/**************
    Տ
 **************/
static
void	init_field(void)
{
static int	dx[4] = {1, -1, 0,  0},
		dy[4] = {0,  0, 1, -1};
	int	i, j, n;

	n = 1;
	for (i = 0; i < LEN; i++) {				/* ՃNA */
		for (j = 0; j < LEN; j++) {
			field[i][j] = ((i == 0) || (i == LEN - 1)
						|| (j == 0) || (j == LEN - 1)) ? 0 : n++;
			field_dx[i][j] = 0;
			field_dy[i][j] = 0;
		}
	}
	spc_x = LEN - 2;					/*  */
	spc_y = LEN - 2;
	field[spc_y][spc_x] = -1;

	n = 1;
	for (i = 0; i < 100; i++) {				/* Vbt */
		do {
			do {
				j = rnd(4);
			} while ( j == (n ^ 1) );		/* Ε */
		} while ( !move_block(dx[j], dy[j]) );		/* ړ */
		n = j;
	}
}

/**********************************
    NA`FbN
	߂l	 TRUE : NA
		FALSE : NA
 **********************************/
static
Bool	check_clear(void)
{
	int	i, j, n;

	n = 1;
	for (i = 1; i < LEN - 1; i++) {
		for (j = 1; j < LEN - 1; j++) {
			if ( (n < (LEN - 2)*(LEN - 2)) && (field[i][j] != n++) ) {
				return	FALSE;
			}
		}
	}
	return	TRUE;
}

/************************************
    Q[C
	߂l	 TRUE : Q[s
		FALSE : I
 ************************************/
static
Bool	game_main(void)
{
	PAD	pad;
	
	draw_back(rnd(4));				/* wi` */
	init_field();					/* Տ */
	while ( !esc_key ) {
		draw_screen();				/* ʕ` */

		pad = get_rept();			/* pbh */

		if ( pad & PAD_UP ) {
			move(0, 1);			/* ړ */
		}
		else if ( pad & PAD_DOWN ) {
			move(0, -1);			/* ړ */
		}
		else if ( pad & PAD_LEFT ) {
			move(1, 0);			/* ړ */
		}
		else if ( pad & PAD_RIGHT ) {
			move(-1, 0);			/* Eړ */
		}
		
		if ( check_clear() ) {			/* NA */
			return	wait_clear();		/* NA\A͑҂ */
		}
	}
	return	FALSE;
}

/************
    C
 ************/
int	main(int argc, char* argv[])
{
	_iocs_tgusemd(0, 2);				/* OtBbNʎgp */
	_iocs_tgusemd(1, 2);				/* eLXgʎgp */
	_dos_c_curoff();				/* J[\nee */
	_iocs_crtmod(0x0e);				/* ʃ[hݒ */
	_iocs_g_clr_on();				/* OtBbNʕ\ */
	_iocs_b_bpoke((void*)0xe82500, 0x24);		/* vCIeBݒ */
	if ( init_screen() ) {				/* ʏ */
		return	1;
	}
	srand((unsigned int)_iocs_timeget());		/*  */

	while ( game_main() );				/* Q[C */

	_iocs_tgusemd(0, 3);				/* OtBbNʎgp */
	_iocs_tgusemd(1, 3);				/* eLXgʎgp */
	_dos_c_width(0);				/* ʃ[hݒ */
	_dos_c_curon();					/* J[\nm */
	_dos_kflushio(0xff);				/* L[obt@NA */

	return	0;
}

