/*
	ZMusic Drive Routine
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<io.h>
#include	<doslib.h>
#include	"zlib.h"
#include	"sound.h"

short	*seq_tbl;				/* Z-muSiC[N̊JnԒn */

static	short	*bgm_data[ BGMNUM ];
static	int	bgm_length[ BGMNUM ];
static	char	*sound_data[ SOUNDNUM ];

/*	aflf[^̃t@Cl[	*/
static char *bgm_filename[ BGMNUM ] = {	"FLF_MU0.ZMD", "FLF_MU1.ZMD",
					"FLF_MU2.ZMD", "FLF_MU3.ZMD",
					"FLF_MU4.ZMD"
};

/*	ʉf[^̃t@Cl[	*/
static char *sound_filename[ SOUNDNUM ] = { "FLF_SE0.ZMD", "FLF_SE1.ZMD",
					    "FLF_SE2.ZMD", "FLF_SE3.ZMD",
					    "FLF_SE4.ZMD"
};

char sound_channel[ SOUNDNUM ] ;


/* TEh
*/
void sd_init()
{
	FILE	*fp ;
	
	int	i , size ;

/*		풓`FbN		*/

	if( z_chk_drv() ) {
		puts( "ZmuSiC풓Ă܂B" ) ;
		exit( 1 ) ;
	}
	seq_tbl = z_get_wk_tbl();

/*		aflf[^݂		*/

	for ( i = 0; i < BGMNUM; i++ ) {
		fp=fopen( bgm_filename[i], "rb" ) ;
		if( fp ) {
			bgm_length[ i ] = size = filelength( fileno( fp ) ) ;
			bgm_data[ i ] = ( short * )MALLOC( bgm_length[ i ] ) ;
			if( bgm_data[ i ] >= ( short * ) 0x81000000 ) {
				printf( "Memory cannot be allocated.\n" ) ;
				exit( 1 ) ;
			}
			/* printf("loading..%s\n", bgm_filename[i]); */
			fread( bgm_data[ i ], 1, bgm_length[ i ], fp ) ;
			fclose( fp ) ;
		} else {
			printf("cannot loading %s\n", bgm_filename[i]);
			exit( 1 );
		}
	}

/*		ʉf[^݂		*/

	for ( i = 0 ; i < SOUNDNUM ; i++ ) {
		fp=fopen( sound_filename[i] , "rb" ) ;
		if( fp != NULL ) {
			size = filelength( fileno( fp ) ) ;
			sound_data[ i ] = ( char * )MALLOC( size ) ;
			if ( sound_data[ i ] >= ( char * ) 0x81000000 ) {
				printf( "Memory cannot be allocated.\n" ) ;
				exit( 1 ) ;
			}
			fread( sound_data[ i ]  , 1 , size , fp ) ;
			sound_channel[ i ] = sound_data[ i ][ 17 ] + 1 ;
			fclose( fp ) ;
		} else {
			printf("cannot loading %s\n", sound_filename[i]);
			exit( 1 );
		}
	}
}


/* aflX^[g
 * @i = BGM Number
*/
void	bgm( int i )
{
/*	z_stop( 0b111111111111111 , 0 , 0 ) ; */
	z_stop( 0, 0, 0 );	/* SgbNt~ */
	if ( i >= 0 ) {
		play_cnv_data( 0 , bgm_data[ i ] ) ;
	}
}


/* ʉ炷
*/
void	sd_on( int i )
{
	se_play( sound_channel[ i ], sound_data[ i ] + 10 );
}
