/******************************

	QSpYf

		

 ******************************/


#include	<sys\iocs.h>

#include	"24puzzle.h"
#include	"pad.h"


static PAD	pad_data = 0xffff;		/* pbh̏ */
static PAD	pad_just;			/* ̕ω */
static PAD	pad_rept;			/* s[gt */
static Bool	read_flag = TRUE;		/* Ԏ擾 */
static int	pad_cnt = 16;			/* s[gpJE^ */

Bool	esc_key  = FALSE;			/* ESCL[ */
Bool	esc_last = TRUE;


/********************
    pbh
 ********************/
void	pad_synch(void)
{
	int	k1, k2;
	PAD	last, last_j, last_r;

	last   = pad_data;			/* Ȍ */
	last_j = pad_just;
	last_r = pad_rept;
	pad_data = ~_iocs_joyget(0);		/* XeBbNf[^擾 */
	k1 = _iocs_bitsns(0x08);		/* L[ */
	k2 = _iocs_bitsns(0x09);
	if ( k1 & 0x10 ) {			/* 8 */
		pad_data |= PAD_UP;
	}
	if ( k2 & 0x10 ) {			/* 2 */
		pad_data |= PAD_DOWN;
	}
	if ( k1 & 0x80 ) {			/* 4 */
		pad_data |= PAD_LEFT;
	}
	if ( k2 & 0x02 ) {			/* 6 */
		pad_data |= PAD_RIGHT;
	}
	k1 = _iocs_bitsns(0x06);
	if ( k1 & 0x20 ) {			/* Xy[X */
		pad_data |= PAD_A;
	}
	k1 = _iocs_bitsns(0x03);
	k2 = _iocs_bitsns(0x09);
	if ( (k1 & 0x20) || (k2 & 0x40) ) {	/* RET,ENTER */
		pad_data |= PAD_B;
	}

	pad_just = pad_data & ~last;		/* ωf[^ */
	pad_rept = pad_just;			/* s[gt */
	if ( pad_data == last ) {
		if ( --pad_cnt == 0 ) {
			pad_rept = pad_data;
			pad_cnt = 4;
		}
	}
	else {
		pad_cnt = 16;
	}
	if ( !read_flag ) {
		pad_just |= last_j;
		pad_rept |= last_r;
	}
	read_flag = FALSE;

	if ( _iocs_bitsns(0) & 0x02 ) {		/* ESCL[ */
		esc_key  = !esc_last;
		esc_last = TRUE;
	}
	else {
		esc_key  = FALSE;
		esc_last = FALSE;
	}
}

/****************************
    pbhԎ擾
	߂l	pbh
 ****************************/
PAD	get_pad(void)			/* ̂܂ */
{
	return	pad_data;
}

PAD	get_push(void)			/*  */
{
	read_flag = TRUE;
	return	pad_just;
}

PAD	get_rept(void)			/* s[gt */
{
	read_flag = TRUE;
	return	pad_rept;
}

/********** End of File *******************************************/