/*
 *		bgput.c( BG character&string output rountine )
 */

#include	<iocslib.h>
#include	"bg.h"

					/* BG ʂɈꕶ\}N */
#define	bgputc( page, x, y, color, char )				\
		*(unsigned short *)( ((page) ? 0xebe000 : 0xebc000)	\
			+ (y) * 128 + (x) * 2 ) = (color) * 256 + (char)

/*
 *	bgputs( page, x, y, color, cp )
 *	afɕ\
 *
 *	int page;			\af̃y[W
 *	int x;				wW
 *	int y;				xW
 *	int color;			F
 *	char *cp;			
 */

void	bgputs( int page, int x, int y, int color, char *cp )
{
	while( *cp != '\0' ) {
		bgputc( page, x++, y, color, -0x20 + BG_SPACE + *cp++ );
	}
}

/*
 *	bgputn( page, x, y, page, num, keta )
 *	af num  keta Ŏw肳ꂽŉElߕ\
 *
 *	int page;			\af̃y[W
 *	int x;				wW
 *	int y;				xW
 *	int color;			F
 *	int num;			\鐔
 *	int keta;			
 *
 * iuwUWOOOQ[EvO~Ov̂̂𑽏ρBj
 */

void	bgputn( int page, int x, int y, int color, int num, int keta )
{
	keta--;
	do {
		bgputc( page, x + keta, y, color,
				(num % 10) + 0x10 + BG_SPACE );
		num /= 10;
	} while( (num > 0) && (--keta >= 0) );

	while( --keta >= 0 ) {
		bgputc( page, x + keta, y, color, BG_SPACE );
	}
}



/* XRA̕\
*/
void score_disp_ini( void )
{
  bgputs( STATUS_BG_PAGE, ZONE_X, ZONE_Y, 1, "ZONE   -" );
  bgputs( STATUS_BG_PAGE,   BP_X,   BP_Y, 1, "BP" );
  bgputs( STATUS_BG_PAGE,   PP_X,   PP_Y, 1, "PP" );
  bgputs( STATUS_BG_PAGE,  PER_X,  PER_Y, 1, "%"  );
}



/* XRA̒lilj̕\
*/
void score_disp_ini2( int lap, int block, int bp, int pp, float per )
{
  bgputn( STATUS_BG_PAGE, ZONE_X + 5, ZONE_Y, 1,        lap, 2 );
  bgputn( STATUS_BG_PAGE, ZONE_X + 8, ZONE_Y, 1,      block, 1 );
  bgputn( STATUS_BG_PAGE,   BP_X + 3,   BP_Y, 1,         bp, 4 );
  bgputn( STATUS_BG_PAGE,   PP_X + 3,   PP_Y, 1,         pp, 2 );
  bgputn( STATUS_BG_PAGE,  PER_X - 3,  PER_Y, 1, ( int )per, 3 );
}



/* XRA̒l̕\
*/
void score_disp( int lap, int block, int bp )
{
  bgputn( STATUS_BG_PAGE, ZONE_X + 5, ZONE_Y, 1,   lap, 2 );
  bgputn( STATUS_BG_PAGE, ZONE_X + 8, ZONE_Y, 1, block, 1 );
  bgputn( STATUS_BG_PAGE,   BP_X + 3,   BP_Y, 1,    bp, 4 );
}
