/*
 *	XvCg[h[`
 */

#include	<stdio.h>
#include	<iocslib.h>
#include	"sp_ld.h"

#define	PCG_NUM		256		/* characters */
#define	PCG_SIZE_MAX	(PCG_NUM * 64)	/* words */

static unsigned short	pcgsize = PCG_SIZE_MAX;
static unsigned short	pcgdata[ PCG_SIZE_MAX ];
static unsigned short	*pcgarea = (unsigned short *)0xeb8000;

static unsigned short	palsize = 16 * 15;
static unsigned short	paldata[ 16 * 16 ];
static unsigned short	*palarea = (unsigned short *)0xe82220;

static char	pcg_fname[ 256 ] = "FLF_FNT.SP";
static char	pal_fname[ 256 ] = "FLF_FNT.PAL";

extern int crtmode;


static void	openerror( char *fname );
static void	load_pcg( void );
static void	load_pal( void );



/* I[vG[̏ꍇ̏I
*/
void	openerror( char *fname )
{
  KFLUSHIO( 0xff );
  CRTMOD( crtmode );	/* ̉ʃ[hɖ߂ */
  B_CURON();
  C_CURON();

  printf( "t@C %s I[vł܂\n", fname );
  exit( 1 );
}



/* load pcg area
*/
void	load_pcg( void )
{
	int	i;
	FILE	*fp;

	fp = fopen( pcg_fname, "rb" );
	if( !fp ) openerror( pcg_fname );
/*	printf( "Reading %s\n", pcg_fname ); */
	fread( pcgdata, 2, pcgsize, fp );
	fclose( fp );

	for( i = 0; i < pcgsize; i++ ){
		*( pcgarea++ ) = pcgdata[ i ];
	}
}



/* load palette area
*/
void	load_pal( void )
{
	int	i;
	FILE	*fp;

	fp = fopen( pal_fname, "rb" );
	if( !fp ) openerror( pal_fname );
/*	printf( "Reading %s\n", pal_fname ); */
	fread( paldata, 2, palsize, fp );
	fclose( fp );

	for( i = 0; i < palsize; i++ ){
		*( palarea++ ) = paldata[ i ];
	}
}



/* .SPf[^  .PALf[^eGAɃ[h
*/
void	sprite_load( void )
{
	pcgarea = (unsigned short *)0xeb8000;

	load_pcg();
	load_pal();
}
