CC	= GCC
AS	= AS
LK	= LK

HEAP	= 65535
STACK	= 65535

CCFLAGS	= -fno-defer-pop -z-heap=$(HEAP) -z-stack=$(STACK)

ASFLAGS	= 

LKFLAGS	= 

LIBS	= $(lib)\clib.l $(lib)\iocslib.l $(lib)\doslib.l $(lib)\baslib.l $(lib)\floatfnc.l $(lib)\gnulib.l

OBJS	= cw2mml.o

PROGRAM	= cw2mml.x

$(PROGRAM)	: $(OBJS)
	$(LK) $(LKFLAGS) -o $(PROGRAM) $^ $(LIBS)

cw2mml.o	: cw2mml.c
	$(CC) $(CCFLAGS) -c -o $@ $< 

